from typing import Any, Optional

from sqlalchemy.orm import Session, Query


class DbService:
    def __init__(self, session: Optional[Session] = None):
        self.session = session

    def commit(self):
        self.session.commit()

    def add(self, instance: Any):
        self.session.add(instance)

    def flush(self):
        self.session.flush()

    def delete(self, instance: Any):
        self.session.delete(instance)

    def query(self, *entities: Any) -> Query:
        return self.session.query(*entities)

    def bulk_save_objects(self, objects: Any):
        self.session.bulk_save_objects(objects)

    def merge(self, instance: Any):
        self.session.merge(instance)

    def rollback(self):
        self.session.rollback()

    def add_all(self, instances: Any):
        self.session.add_all(instances)
